#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivityFishingCeleExchangeCFG.h"
std::auto_ptr<M_ActivityFishingCeleExchangeCFG> M_ActivityFishingCeleExchangeCFG::msSingleton(nullptr);

int M_ActivityFishingCeleExchangeCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityFishingCeleExchangeCFGData* M_ActivityFishingCeleExchangeCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivityFishingCeleExchangeCFGData>& M_ActivityFishingCeleExchangeCFG::GetMapData()
{
	return mMapData;
}

void M_ActivityFishingCeleExchangeCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivityFishingCeleExchangeCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityFishingCeleExchangeCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mType = element->IntAttribute("Type");
		data.mNeedItem = element->IntAttribute("NeedItem");
		data.mNeedCount = element->IntAttribute("NeedCount");
		data.mDiscountCount = element->IntAttribute("DiscountCount");
		data.mItemId = element->IntAttribute("ItemId");
		data.mItemCount = element->IntAttribute("ItemCount");
		data.mLimit = element->IntAttribute("Limit");
		data.mProbItem = element->IntAttribute("ProbItem");
		data.mProbCount = element->IntAttribute("ProbCount");
		data.mProb = element->IntAttribute("Prob");
		data.mGiftDiscount = element->IntAttribute("GiftDiscount");
		data.mLvLimit = element->IntAttribute("LvLimit");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivityFishingCeleExchangeCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityFishingCeleExchangeCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivityFishingCeleExchangeCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivityFishingCeleExchangeCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivityFishingCeleExchangeCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "Type", data.mType);
		LuaCfgHelper::readInt(L, "NeedItem", data.mNeedItem);
		LuaCfgHelper::readInt(L, "NeedCount", data.mNeedCount);
		LuaCfgHelper::readInt(L, "DiscountCount", data.mDiscountCount);
		LuaCfgHelper::readInt(L, "ItemId", data.mItemId);
		LuaCfgHelper::readInt(L, "ItemCount", data.mItemCount);
		LuaCfgHelper::readInt(L, "Limit", data.mLimit);
		LuaCfgHelper::readInt(L, "ProbItem", data.mProbItem);
		LuaCfgHelper::readInt(L, "ProbCount", data.mProbCount);
		LuaCfgHelper::readInt(L, "Prob", data.mProb);
		LuaCfgHelper::readInt(L, "GiftDiscount", data.mGiftDiscount);
		LuaCfgHelper::readInt(L, "LvLimit", data.mLvLimit);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivityFishingCeleExchangeCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityFishingCeleExchangeCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivityFishingCeleExchangeCFG* M_ActivityFishingCeleExchangeCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityFishingCeleExchangeCFG());
	}
	return msSingleton.get();
}

void M_ActivityFishingCeleExchangeCFG::Release()
{
	msSingleton.reset(nullptr);
}
